Lua_BulletinBoardSecWindow = class("Lua_BulletinBoardSecWindow", Lua_Window);
function Lua_BulletinBoardSecWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.TIPS_WINDOW_LAYER;
    self.windowName = "Lua_BulletinBoardSecWindow";
    self.isFullSizeWin = true;
    self.openSound = "";
    self.closeSound = "";

	self.isRunning = false;
	self.list = Array();
end

function Lua_BulletinBoardSecWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.bgSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_zjm_bj_01", 0, -132.5, 698, 39);
    self.bgSp.anchorValue = 1;

    self.txt = UICreate.createLabel(self.content, "", 0, -132.5, 698, 39, 22);
    self.txt.anchorValue = 1;
    self.txt.pivotValue = 4;
    self.txt.alignmentValue = 4;
    self.txt.clickScale = false;
    self.txt:addUrlClickFuntion(self, self.onClickTxt);
end

function Lua_BulletinBoardSecWindow:onClickTxt(urlStr)
    if self.data == nil then
        return;
    end
    Lua_ChatUtil.urlClickHandle(urlStr, self.data);
end

function Lua_BulletinBoardSecWindow:showWin(param)
	self:superCall("showWin", param);
	local bv = param;
    for i = 1, bv.circle do
        self.list:add(bv);
    end
    self:sortList();
    
    while (self.list:getSize() > Lua_CommonUtil.getCommonConfig("broadcast_limit", 1)) do
        self.list:shift();
    end

    -- if self.isRunning == true then -- 检测计时器是否有
    --     self.isRunning = Lua_CommonUtil.addTimer("onShowNextInfo", 0.02, self, self.onShowNextInfo, nil, -1);
    -- end

	if self.isRunning == nil or self.isRunning == false then
		self:updateData();
	end
end

function Lua_BulletinBoardSecWindow:sortList()
    local count = self.list:getSize();
    for i = 1, count do
        for j = i + 1, count do
            local a1 = self.list[i].priority;
            local b1 = self.list[j].priority;
            if a1 < b1 then
                local temp = self.list[i];
                self.list[i] = self.list[j];
                self.list[j] = temp;
            end
        end
    end
end

function Lua_BulletinBoardSecWindow:updateData()
    if self.list:getSize() > 0 then
        self.data = self.list:shift();
        self.txt.text = self.data.content;
        self.txt.alpha = 1;
        self.curTime = getTime();
        self.runeTime = self.data.showTime;
        self.txt:setLocation(0, -132.5, 0);
        if self.data.notice == 2 then
            local txtLen = self.txt:GetFontlen(self.txt.text);
            self.startX = MainWinDefine.V_width / 2 + txtLen / 2;
            self.txt:setLocation(self.startX, -132.5, 0);
        else
            self.hideTime = self.runeTime * 0.3;
            self.tempStep = 1 / (self.hideTime / 0.02);
            self.temp = self.tempStep;
        end

    	if self.isRunning == nil or self.isRunning == false then
            self.isRunning = true;
            Lua_CommonUtil.addTimer("onShowNextInfo", 0.02, self, self.onShowNextInfo, nil, -1);
        end
    else
        self:hide();
    end
end

function Lua_BulletinBoardSecWindow:onShowNextInfo()
    if self.data.notice == 2 then
        local tempTime = getTime() - self.curTime
        if tempTime >= self.runeTime then
            self:updateData();
        else
            local pos_x = self.startX - self.startX * 2 * (tempTime / self.runeTime);
            self.txt:setLocation(pos_x, -132.5, 0);
        end
    else
        local num = getTime();
        self.runeTime = self.runeTime - (num - self.curTime);
        self.curTime = num;
        if self.runeTime <= 0 then
            self:updateData();
        elseif self.runeTime <= self.hideTime then
            self.txt.alpha = 1 - self.temp;
            self.temp = self.temp + self.tempStep;
        end
    end
end

function Lua_BulletinBoardSecWindow:dispose()
    if self.list ~= nil then
        self.list:clear();
        self.list = nil;
    end

    self.data = nil;
	if self.isRunning == true then
		self.isRunning = false;
		Lua_CommonUtil.removeTimer(self, self.onShowNextInfo);
	end
	self:superCall("dispose");
end