checkRequire("Lua_ChatFacePanel");
checkRequire("Lua_ChatToolPanel");
Lua_ChatAddItemWindow = class("Lua_ChatAddItemWindow", Lua_Window);
function Lua_ChatAddItemWindow:ctor()
	self:superCall("ctor");

    self.blackAlpha = 0.01;
    self.showBlackMask = true;
	self.isClickClose = true;
    self.showCloseText = false;

    self.offsetX=0;
    self.offsetY=0;
    self.isAdapter=true;

    self.windowName = "Lua_ChatAddItemWindow";
end

function Lua_ChatAddItemWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.bg = UICreate.createUIAtlasImage(self.content, "iconantlas2", "Chat_widget_08", 0, -300, 620, 190);

    self.panelIndex=-1;
    self.curPanel = nil;
    self.tabList= Array();
    self.tabList:add({textAtlas = "iconantlas2", textNormalSprite = "Chat_fonts_01", panel=Lua_ChatFacePanel});
    self.tabList:add({textAtlas = "iconantlas2", textNormalSprite = "Chat_fonts_02", panel=Lua_ChatToolPanel});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Vertical);
    self.btnList:setButtonStyle("iconantlas2", "Chat_btn_01", "Chat_btn_01_s", 45, 91);
    self.btnList:setButtonItem(45, 92);
    self.btnList:setLocation(290, -300, 0);
    self.btnList:setData(self.tabList);
    self.btnList:setClickCallBack(self, self.onBtnClick);
    self.btnList:setSelected(1);

    self:addLuaEvent("UPDATE_SCREEN", self, self.updateScreen);
    self:updateScreen();
end

function Lua_ChatAddItemWindow:updateScreen()
    if self.isAdapter==false then
        return;
    end
    -- self.content.transform.localPosition = Vector3(self.offsetX, MainWinDefine.DEFAULT_HEIGHT/2-MainWinDefine.V_height / 2+self.offsetY, 0);
    LuaUtil.setObjPos(self.content, self.offsetX, MainWinDefine.DEFAULT_HEIGHT/2-MainWinDefine.V_height / 2+self.offsetY, 0);
end

function Lua_ChatAddItemWindow:showWin(param)
    self:superCall("showWin", param);
    self.param = param;
    if param ~= nil then
        if param.offsetX ~= nil then
            self.offsetX=param.offsetX;
        end
        if param.offsetY ~= nil then
            self.offsetY=param.offsetY;
        end
        if param.isAdapter ~= nil then
            self.isAdapter=param.isAdapter;
        end
        if self.isAdapter == false then
            -- self.content.transform.localPosition = Vector3(self.offsetX, self.offsetY, 0);
            LuaUtil.setObjPos(self.content, self.offsetX, self.offsetY, 0);
        else
            -- self.content.transform.localPosition = Vector3(self.offsetX, MainWinDefine.DEFAULT_HEIGHT/2-MainWinDefine.V_height / 2+self.offsetY, 0);
            LuaUtil.setObjPos(self.content, self.offsetX, self.offsetX, MainWinDefine.DEFAULT_HEIGHT/2-MainWinDefine.V_height / 2+self.offsetY, 0);
        end
    end
end
function Lua_ChatAddItemWindow:onBtnClick(val)
    if self.panelIndex == val then
        return;
    end
    local objClass = self.tabList[val].panel;
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self.panelIndex = val;
    self.curPanel = objClass.new(self.content);
end

function Lua_ChatAddItemWindow:dispose()
    if self.tabList ~= nil then
        self.tabList:clear();
        self.tabList = nil;
    end

    if self.btnList ~= nil then
        self.btnList:dispose();
        self.btnList=nil;
    end

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self:superCall("dispose");
end