
Lua_ChatSetUpWindow = class("Lua_ChatSetUpWindow", Lua_Window);
function Lua_ChatSetUpWindow:ctor()
	self:superCall("ctor");
	self.w = 670;
    self.h = 700;
    self.showBlackMask = true;
    
	self.windowName = "Lua_ChatSetUpWindow";
	self.skinName = "ChatSetUpWindow_skin";
end

function Lua_ChatSetUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.cur_setting = {};

	--勾选框
	self.worldBox:setDir(1);
	self.worldBox.txt.text = LanUtil.getValue(171001);
	self.worldBox:addBoxChange(self, self.onWorldBoxChange);

	self.warBox:setEnable(false);
	-- self.warBox:setDir(1);
	-- self.warBox.txt.text = LanUtil.getValue(171005);
	-- self.warBox:addBoxChange(self, self.onWarBoxChange);
	self.allianceBox:setDir(1);
	self.allianceBox.txt.text = LanUtil.getValue(171002);
	self.allianceBox:addBoxChange(self, self.onAllianceBoxChange);
	self.allianceBox:setLocation(26, 7);

	self.privateBox:setDir(1);
	self.privateBox.txt.text = LanUtil.getValue(171004);
	self.privateBox:addBoxChange(self, self.onPrivateBoxChange);
	self.privateBox:setLocation(236, 7);
	self.saveBtn:addClickFuntion(self, self.onSaveBtnClick);

	self:updatePanel();
end


function Lua_ChatSetUpWindow:updatePanel()

	self.cur_setting[Lua_ChatData.CHANNEL_WORLD]= DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_WORLD);
	self.cur_setting[Lua_ChatData.CHANNEL_CROSS_SERVER]= DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_CROSS_SERVER);
	self.cur_setting[Lua_ChatData.CHANNEL_LEAGUE]= DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_LEAGUE);
	self.cur_setting[Lua_ChatData.CHANNEL_FRIEND]= DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND);

	self.worldBox.selected = DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_WORLD) == 1 and true or false;
	self.warBox.selected = DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_CROSS_SERVER) == 1 and true or false;
	self.allianceBox.selected = DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_LEAGUE) == 1 and true or false;
	self.privateBox.selected = DataCenter.chatData:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 1 and true or false;
end

function Lua_ChatSetUpWindow:onWorldBoxChange(val)
	self.cur_setting[Lua_ChatData.CHANNEL_WORLD]= val == true and 1 or 0;
end

function Lua_ChatSetUpWindow:onWarBoxChange(val)
	self.cur_setting[Lua_ChatData.CHANNEL_CROSS_SERVER]= val == true and 1 or 0;
end

function Lua_ChatSetUpWindow:onAllianceBoxChange(val)
	self.cur_setting[Lua_ChatData.CHANNEL_LEAGUE]= val == true and 1 or 0;
end

function Lua_ChatSetUpWindow:onPrivateBoxChange(val)
	self.cur_setting[Lua_ChatData.CHANNEL_FRIEND]= val == true and 1 or 0;
end

function Lua_ChatSetUpWindow:onSaveBtnClick()
	if next(self.cur_setting) ~= nil then
		local cmd = ProtoPublic_pb.Proto10105011();
		for k,v in pairs(self.cur_setting) do
			if v == 0 then
				cmd.channel_list:append(k);
			end
		end
		sendMsg(10105011, cmd);
	end
	self:hide();
end

function Lua_ChatSetUpWindow:dispose()
	self:superCall("dispose");
end
