checkRequire("Lua_ChatDragContainerItem");
checkRequire("Lua_ChatChanelItem");
checkRequire("Lua_ChatFriendHeadItem");
Lua_ChatWindow = class("Lua_ChatWindow", Lua_Window);
function Lua_ChatWindow:ctor()
    self:superCall("ctor");

    self.isFullSizeWin = true;
    self.showBlackMask = true;

    self.windowName = "Lua_ChatWindow";
    self.skinName = "ChatWindow_skin";
end

function Lua_ChatWindow:showWin(param)
	self:superCall("showWin", param);
	self.toindex = nil;
	if type(param) == "table" and param.openIdx ~= nil then
		self.toindex = param.openIdx;
	elseif type(param) == "number" then
		self.toindex = param;
	end
    for i = 1, self.btnNames:getSize() do
        if self.toindex == self.btnNames[i].id then
            self.btnList:moveToIndex(i,true);
        end
    end
	if self.toindex ~= nil and self.btnList ~= nil and self.btnList.showList:getSize() >= 0 then
		self:onButtonListClick(self.toindex);
	end

    self.backSp:addClickFuntion(self, self.hide);
end

function Lua_ChatWindow:buildShowItem()
	self:superCall("buildShowItem");

    --版署屏蔽修改
    self.voiceBtn:setEnable(false);
    self.msgBg:SetDimensions(456, 56);
    self.msgBg:setLocation(-341, -479);
    self.msgText:SetDimensions(438, 32);
    self.msgText:setLocation(-328, -480.4);

    -- inputText默认提示信息
    self.defaultLangId = 171006
	self.defaultMsg = LanUtil.getValue(self.defaultLangId);
    self.msgText:setDefaultLangValue(self.defaultLangId)
	self.msgText.text = "";
    self.curInputLen = 0;
    self.lastTextContent = "";
    self.msgText:onChange(self, self.onInputTextChangeShow);

    -- 消息dragContainer
    self.dragContainer = Lua_DragContainer.new(self.downObj, 680, 1000, Lua_AxisDefine.Vertical);
    self.dragContainer:setRectPivot(7);
    self.dragContainer:setLocation(0, -425, 0);

    -- @提示
    self.pointObject.transform:SetSiblingIndex(11);

    -- 私聊窗口
    self.friendList = Lua_DragList.new(self.downObj, 685, 150, Lua_AxisDefine.Horizontal);
    self.friendList:setListCell(Lua_ChatFriendHeadItem, 125, 150, 1);
    self.friendList:setLocation(0, 525 + self.adaptHeight, 0);

    -- 层级设置
    self.inputObject.transform:SetSiblingIndex(13);
    self.backSp.siblingIndex = 14;
    self.settingSp.siblingIndex = 15;

    -- 渠道list
    self.btnBg:setAltas("common_altas_1", "ui_common_widget_005");
    self.btnList = Lua_DragList.new(self.downObj, 720,77, Lua_AxisDefine.Horizontal);
    self.btnList:setListCell(Lua_ChatChanelItem, 180, 77, 1);
    self.btnList.canDrag = false;
    self.btnList:setLocation(0, -564, 0);
    self.btnNames = DataCenter.chatData:getChatChannelConfig();
    self.btnList:setArrayData(self.btnNames);

    -- 点击遮罩
    self.clickMask = UICreate.createUIAtlasImage(self.inputObject, "common_altas_1", "ui_common_bg_002", 0, 0, 720, 1440);
    self.clickMask.name = "clickMask";
    self.clickMask.siblingIndex = 2;
    self.clickMask.alpha = 0.01;
    self.clickMask.anchorValue = 1;
    self.clickMask:addClickFuntion(self, self.onCloseFacePanel);
    self.clickMask:SetDimensions(720, 1440 + self.adaptHeight);
    self.clickMask:setLocation(0, self.adaptHeight/2, 0);

    -- 事件点击
    self.voiceBtn:addClickFuntion(self,self.onVoiceClick); -- 切换语音按钮
    self.addBtn:addClickFuntion(self, self.onAddBtnClick); -- 添加表情按钮
    self.sendBtnIcon:addClickFuntion(self, self.onSendClick); -- 发送按钮
    self.keyboard:addClickFuntion(self, self.onKeyboardClick); -- 切换键盘按钮

    self.soundBtn.clickScale = false; -- 语音设置
    self.soundBtn:addMousDownFuntion(self, self.onSoundClick);
    self.soundBtn:addMouseUpFuntion(self, self.onSoundUpClick);

    self.pointBg:addClickFuntion(self, self.onPointClick); -- @事件
    self.settingSp:addClickFuntion(self, self.onSettingSpClick); -- 消息红点提示设置

    self.act_checkBox:addBoxChange(self,self.onCheckBoxChange);-- 是否显示节目联动信息box
    self.act_checkBox.selected = DataCenter.chatData.act_check_state;

    -- 点击lua事件
    self:addLuaEvent("CHAT_CHANEL_CHANGE", self, self.onButtonListClick);
    self:addLuaEvent("ADD_CHAT_MSG", self, self.onChatUpdate);
    self:addLuaEvent("CHAT_SHOW_TYPE_UPDATE", self, self.onChatShowItemChange);
    self:addLuaEvent("CHAT_ADD_FACE", self, self.onFaceSelected); -- 聊天输入框  输入 表情
    self:addLuaEvent("CHAT_FRIEND_SELECT", self, self.onFriendChatChange);
    self:addLuaEvent("CHAT_FRIEND_CLOSE", self, self.updataPrivateList);
    self:addCSharpEvent("VOICE_DONE", self, self.onVoiceDown);
    self:addLuaEvent("CHAT_UPDATE_FRIEND", self, self.updataPrivateAvtor);
    
    self:onScreenResize();
    self:onChatShowItemChange();
    self:createFaceContent(); -- 表情界面
end

function Lua_ChatWindow:onInputTextChangeShow()
    local infactLen = self:calculateInputTextLen(); 
    local totalLen = self.sendCharacterLimit;-- / 2;
    local validLen = infactLen > totalLen and self.curInputLen or infactLen;
    if infactLen > totalLen then
        self.msgText.text = self.lastTextContent;--string.sub(self.msgText.text, 1, validLen);
    else
        self.curInputLen = validLen;
        self.lastTextContent = self.msgText.text;
    end
end

-- 计算输入框的字符长度
function Lua_ChatWindow:calculateInputTextLen()
    local arr = Lua_ChatUtil.genChatString(self.msgText.text);
    local curLen = 0;
    local chineseLen = 3; -- utf8中中文的长度，表情当成一个中文输入
    for i = 1, arr:getSize() do
        if Lua_ChatUtil.isChatFace(arr[i]) == true then
            curLen = curLen + chineseLen;
        else
            curLen = curLen + string.len(arr[i]);
        end
    end
    return curLen;
end

-- 关闭表情选框
function Lua_ChatWindow:onCloseFacePanel()
    self.clickMask:setEnable(false);
    if self.faceObj.activeSelf then
        self.faceObj:SetActive(false);
    end
end

-- 创建表情内容
function Lua_ChatWindow:createFaceContent()
    self.faceBg = UICreate.createUIAtlasImage(self.faceObj, "chat_atlas", "ui_liaotian_window_006", 0, -300, 620, 190);
    self.faceList = Lua_DragList.new(self.faceObj, 565,170, Lua_AxisDefine.Vertical);
    self.faceList:setListCell(Lua_FaceItem, 55, 55, 10);
    --self.btnList:setCellSpacing(20,17);
    self.faceList:setLocation(10, -300, 0);

    local list=Array();
    for i = 1, Lua_ChatUtil.MAX_FACE_INDEX do
        local str = tostring(i);
        if string.len(str) == 1 then
            str = "00"..str;
        elseif string.len(str) == 2 then
            str = "0"..str;
        end
        list:add(str);
    end
    self.faceList:setArrayData(list);
    -- self.faceObj:setLocation(0, 698);
    self.faceObj:SetActive(false);
end

function Lua_ChatWindow:onScreenResize()
    self:superCall("onScreenResize");

    self.winBg:SetDimensions(720, 1236 + self.adaptHeight);
    self.privateBg:setLocation(0, 525.5 + self.adaptHeight, 0);
    if self.clickMask ~= nil then
        self.clickMask:SetDimensions(720, 1440 + self.adaptHeight);
        self.clickMask:setLocation(0, self.adaptHeight/2, 0);
    end

    if self.dragContainer ~= nil then
        if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then
            self.dragContainer:setContentRect(680, 850 + self.adaptHeight);
        else
            self.dragContainer:setContentRect(680, 1000 + self.adaptHeight);
        end
    end

    if self.friendList ~= nil then
        self.friendList:setLocation(0, 525 + self.adaptHeight, 0);
    end
end

function Lua_ChatWindow:onCheckBoxChange(val)
    DataCenter.chatData.act_check_state=val;
    local cmd = ProtoPublic_pb.Proto10105009();
    cmd.state = val==true and 1 or 0;
    sendMsg(10105009, cmd);
end

function Lua_ChatWindow:onSettingSpClick(go)
    self:onCloseFacePanel();
    Lua_WindowUtil.openWin("Lua_ChatSetUpWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ChatWindow:onPointClick()
    local pointList=DataCenter.chatData:getPointList(self.selectChannel);
    self.dragContainer:moveToIndex(tonumber(pointList[pointList:getSize()]), false,true);
    DataCenter.chatData:reomvePointListItem(self.selectChannel,pointList[pointList:getSize()]);
    if pointList:getSize()>0 then
        self.pointObject:SetActive(true);
    else
        self.pointObject:SetActive(false);
    end
end

function Lua_ChatWindow:onVoiceClick()
    --if Lua_PlatformUtil.IsWindowsEditor() or Lua_PlatformUtil.IsWindowsPlayer() then
    --    OperateAlert.showLangValue(171030);
    --    return;
    --end

    --if not DataCenter.funcOpenData:isOpened(10174,true) then
    --    return;
    --end

    if tonumber(DataCenter.chatData.selectPrivate) == 0 and self.selectChannel==Lua_ChatData.CHANNEL_FRIEND then
        OperateAlert.showLangValue(171021);
        return;
    end

    self.inputObject:SetActive(false);
    self.voiceObject:SetActive(true);
end

function Lua_ChatWindow:onKeyboardClick()
    self.inputObject:SetActive(true);
    self.voiceObject:SetActive(false);
end

function Lua_ChatWindow:onFriendChatChange(item)
    if tonumber(item) == tonumber(DataCenter.chatData.selectPrivate) then
        return;
    end

    DataCenter.chatData.selectPrivate=tonumber(item);
    for i = 1, self.friendList.showList:getSize() do
        self.friendList.showList[i]:setSelected();
    end

    local list = DataCenter.chatData:getPrivateMsgList(DataCenter.chatData.selectPrivate);
    self:updateChatList(list);
    self:updataChannelTag();
end

function Lua_ChatWindow:updataPrivateList()
    local privateList=DataCenter.chatData:getShowPrivateList();
    local tempId=0;

    if tonumber(DataCenter.chatData.selectPrivate) == 0 then
        for i = 1, privateList:getSize() do
            local redCount=DataCenter.chatData:getPrivateNewMsgNum(privateList[i].id);
            if redCount>0 then
                tempId=tonumber(privateList[i].id);
                break;
            end
        end
        if tempId == 0 and privateList:getSize()>0 then
            DataCenter.chatData.selectPrivate=tonumber(privateList[privateList:getSize()].id);
        else
            DataCenter.chatData.selectPrivate=tonumber(tempId);
        end
    end

    local list = DataCenter.chatData:getPrivateMsgList(tonumber(DataCenter.chatData.selectPrivate));
    self:updateChatList(list);

    local show_limit=Lua_ChatChannelData.getConfigDataById(Lua_ChatData.CHANNEL_FRIEND).showPrivateCount;
    local flist=Array();
    if privateList:getSize()<show_limit then
        flist:add({notMax=true});
    end
    for i=privateList:getSize(),1,-1 do
        flist:add(privateList[i]);
    end
    self.friendList:setArrayData(flist);

    local isHasFriend = flist:getSize() <= 1;
    self.noneObject:SetActive(isHasFriend);
    self.msgText.inputMouseEnable =  not isHasFriend;
    self:updataChannelTag();
end

-- 更新私聊窗口头像
function Lua_ChatWindow:updataPrivateAvtor()
    local privateList=DataCenter.chatData:getShowPrivateList();
    local show_limit=Lua_ChatChannelData.getConfigDataById(Lua_ChatData.CHANNEL_FRIEND).showPrivateCount;
    local flist=Array();
    if privateList:getSize()<show_limit then
        flist:add({notMax=true});
    end
    for i=privateList:getSize(),1,-1 do
        flist:add(privateList[i]);
    end
    self.friendList:setArrayData(flist);
end

function Lua_ChatWindow:onChatShowItemChange(o)
	local showType = DataCenter.chatData.contentType;
	local vitem = DataCenter.chatData.contentData;
	if showType ~= 0 and self.selectChannel ~= Lua_ChatData.CHANNEL_SYSTEM then
		if showType == Lua_ChatData.CONTENT_XUANYAO then
			if self.curItemId ~= vitem.id then
				self.curItemId = vitem.id;
				self.msgText.text = "["..vitem.name.."]";
			end
		elseif showType == Lua_ChatData.CONTENT_POINT then
            self.msgText.text ="@"..vitem.name.."◆";
		end
	end
end

function Lua_ChatWindow:onButtonListClick(val)
    self:onCloseFacePanel();

    if Lua_ChatUtil.checkChannelOpen(val, true) == false then
        return;
    end

    if val == self.selectChannel then
        return;
    end

	self.selectChannel = val;
    DataCenter.chatData.openChannelTag=val;
    -- 发送的字符数限制
    self.sendCharacterLimit = Lua_ChatChannelData.getConfigDataById(Lua_ChatData.CHANNEL_WORLD).num_limit;
    self.actObject:SetActive(false);

    self.voiceObject:SetActive(false);
    self.inputObject:SetActive(true);
    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_SYSTEM then
        self.pointObject:SetActive(false);

        self.voiceBtn:setAltas("chat_atlas", "ui_liaotian_button_001_d");
        self.voiceBtn.mouseEnable = false;
        self.addBtn:setAltas("chat_atlas", "ui_liaotian_button_002_d");
        self.addBtn.mouseEnable = false;
        self.sendBtnIcon:setAltas("chat_atlas", "ui_liaotian_button_003_d");
        self.sendBtnIcon.mouseEnable = false;
        self.sendBtnTxt.colorStr = Lua_ColorDefine.transColorStr("717171");

        self.msgText.text = "";
        self.msgText:setDefaultLangValue(171032)
        self.msgText.inputMouseEnable = false;
    else
        self.voiceBtn:setAltas("chat_atlas", "ui_liaotian_button_001_n");
        self.voiceBtn.mouseEnable = true;
        self.addBtn:setAltas("chat_atlas", "ui_liaotian_button_002_n");
        self.addBtn.mouseEnable = true;
        self.sendBtnIcon:setAltas("chat_atlas", "ui_liaotian_button_005_n");
        self.sendBtnIcon.mouseEnable = true;
        self.sendBtnTxt.colorStr = Lua_ColorDefine.transColorStr("8b5e34");

        self.msgText:setDefaultLangValue(self.defaultLangId)
        self.msgText.inputMouseEnable = true;
    end
    
    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then
        self.dragContainer:setContentRect(680, 850 + self.adaptHeight);
        self.friendList:setEnable(true);
        self:updataPrivateList();
        DataCenter.chatData:setChannelNewMsgNum(self.selectChannel,0);
        self.pointObject:SetActive(false);
        self.privateBg:setEnable(true);
    else
        self.dragContainer:setContentRect(680, 1000 + self.adaptHeight);
        if self.friendList ~= nil then
            self.friendList:setEnable(false);
        end
        local list = DataCenter.chatData:getChannelMsgList(self.selectChannel);
        DataCenter.chatData:setChannelNewMsgNum(self.selectChannel,0);
        self:updateChatList(list);
        DataCenter.chatData.selectPrivate=0;
        local pointList=DataCenter.chatData:getPointList(self.selectChannel);
        if pointList:getSize()>0 then
            self.pointObject:SetActive(true);
        else
            self.pointObject:SetActive(false);
        end
        self.noneObject:SetActive(false);
        self.privateBg:setEnable(false);
        self:updataChannelTag();
    end
end

function Lua_ChatWindow:updataChannelTag()
    for i = 1, self.btnList.showList:getSize() do
        self.btnList.showList[i]:setSelected();
    end   
end

function Lua_ChatWindow:onChatUpdate(chatVo)
	local c = chatVo.channel;
    self:updataChannelTag();
	if (c == Lua_ChatData.CHANNEL_WORLD and self.selectChannel == Lua_ChatData.CHANNEL_WORLD)
		or (c == Lua_ChatData.CHANNEL_LEAGUE and self.selectChannel == Lua_ChatData.CHANNEL_LEAGUE)
		or (c == Lua_ChatData.CHANNEL_SYSTEM and self.selectChannel == Lua_ChatData.CHANNEL_SYSTEM)
		or (c == Lua_ChatData.CHANNEL_CROSS_SERVER and self.selectChannel == Lua_ChatData.CHANNEL_CROSS_SERVER) then
		self:addNewChat(chatVo);
	end
    if c == Lua_ChatData.CHANNEL_FRIEND and self.selectChannel == Lua_ChatData.CHANNEL_FRIEND then
        local chatId = chatVo.private_player.id;
        if Lua_ChatUtil.judgeIsPlayer(chatId) then --私聊目标为自身时 
            chatId = chatVo.chat_player.id;
        end
        
        if tonumber(chatId) ~= tonumber(DataCenter.chatData.selectPrivate) then 
            self:updataPrivateList(); -- 不是发送的目标时执行
        else
            self:addNewChat(chatVo);
        end
    end
end

function Lua_ChatWindow:addNewChat(chatVo)
    local msg_limit = Lua_ChatChannelData.getConfigDataById(self.selectChannel).msg_limit;
    local chatLen = self.dragContainer.showDragDataList:getSize();
    if self.selectChannel == Lua_ChatData.CHANNEL_FRIEND then
        local list = DataCenter.chatData:getPrivateMsgList(DataCenter.chatData.selectPrivate);
        self.dragContainer:clearList();
        for i = 1, list:getSize() do
            self.dragContainer:addSubContainer(Lua_ChatDragContainerItem, list[i], false);
        end
        self.dragContainer:updateChildPos();
    else
        if chatLen >= msg_limit then
            local list = DataCenter.chatData:getChannelMsgList(self.selectChannel);
            -- if self.selectChannel == Lua_ChatData.CHANNEL_FRIEND then
            --     list = DataCenter.chatData:getPrivateMsgList(DataCenter.chatData.selectPrivate);
            -- end
            self.dragContainer:setChildData(list,false);
        else
            self.dragContainer:addSubContainer(Lua_ChatDragContainerItem,chatVo,true);
        end
    end

    if chatLen > 4 then
        self.dragContainer:moveToIndex(chatLen,true);
    end
end
function Lua_ChatWindow:updateChatList(chatList)
    local chatLen = self.dragContainer.showDragDataList:getSize();
    local tempLen = chatList:getSize() - chatLen;
    if tempLen >= 0 then
        while tempLen > 0 do
            self.dragContainer:addSubContainer(Lua_ChatDragContainerItem,nil,false);
            tempLen = tempLen - 1;
        end
    else
        while tempLen < 0 do
            local item = self.dragContainer.showDragDataList:remove(1);
            item:returnCellToPool();
            item:dispose();
            tempLen = tempLen + 1;
        end
    end
        self.dragContainer:clearList();

    for i = 1, chatList:getSize() do
        self.dragContainer:addSubContainer(Lua_ChatDragContainerItem, chatList[i], false);
    end
    self.dragContainer:updateChildPos();
    -- self.dragContainer:setChildData(chatList,false);

    if chatList:getSize()>4 then
        self.dragContainer:moveToIndex(chatList:getSize(),true);
    end

end
function Lua_ChatWindow:onAddBtnClick(go)
    if tonumber(DataCenter.chatData.selectPrivate) == 0 and self.selectChannel==Lua_ChatData.CHANNEL_FRIEND then
        OperateAlert.showLangValue(171021);
        return;
    end
    local isShow = self.faceObj.activeSelf;
    self.faceObj:SetActive(not isShow);
    self.clickMask:setEnable(not isShow);
	-- local p = {};
	-- p.offsetX = 0;
	-- p.offsetY = 0;
 --    p.isAdapter=false;
 --    if DataCenter.chatData.openChannelTag ~= Lua_ChatData.CHANNEL_WORLD then
 --        p.offsetY = -35;
 --    end
	-- Lua_WindowUtil.openWin("Lua_ChatAddItemWindow", Lua_WinParam.ACTION_OPEN, p);
end

function Lua_ChatWindow:onFaceSelected(val)
	-- if self.msgText.text == self.defaultMsg then
	-- 	self.msgText.text = "/"..val;
	-- else
	-- 	self.msgText.text = self.msgText.text.."/"..val;
    --     -- print(val);
	-- end
    self.faceObj:SetActive(false);
    self.clickMask:setEnable(false);
    Lua_ChatUtil.sendMsg(self.selectChannel, "/"..val, true, true);
end

function Lua_ChatWindow:onSoundClick(go)
	Lua_WindowUtil.openWin("Lua_ChatSoundWindow", Lua_WinParam.ACTION_OPEN,10);
	if ChatRecordSound.getInstance():startRecord() == true then
        self.voiceStarTime=getTime();
        self.voice_limit = Lua_ChatChannelData.getConfigDataById(self.selectChannel).voice_limit;
        Lua_CommonUtil.addTimer( "checkVoiceTime", 0.01, self, self.checkVoiceTime);
    else
        self.soundBtn:setScale(1, 1);
        self:onSoundUpClick(nil);
    end
end

function Lua_ChatWindow:onSoundUpClick(go)
	Lua_WindowUtil.openWin("Lua_ChatSoundWindow", Lua_WinParam.ACTION_CLOSE);
    self.isCancel = false;
    self.soundBtn:setScale(1, 1);
	ChatRecordSound.getInstance():stopRecord();
    Lua_CommonUtil.removeTimer(self,self.checkVoiceTime);
end

function Lua_ChatWindow:checkVoiceTime()
    if (getTime() - self.voiceStarTime) >= self.voice_limit then
        self:onSoundUpClick(nil);
    end
end

function Lua_ChatWindow:onVoiceDown(o)
	if self.isCancel == false then
        Lua_ChatUtil.sendVoiceMsg(self.selectChannel);
	end
	ChatRecordSound.getInstance():clear();
end

function Lua_ChatWindow:onSendClick(go)
    self:onCloseFacePanel();

    if tonumber(DataCenter.chatData.selectPrivate) == 0 and self.selectChannel==Lua_ChatData.CHANNEL_FRIEND then
        OperateAlert.showLangValue(171021);
        return;
    end

    -- 私聊当中删除或拉黑，非好友
    local isFriend = DataCenter.friendData:isFriendById(DataCenter.chatData.selectPrivate);
    if self.selectChannel==Lua_ChatData.CHANNEL_FRIEND and not isFriend then
        OperateAlert.showLangValue(171038);
        self.curItemId = nil;
        self.msgText:setDefaultLangValue(self.defaultLangId)
        self.msgText.text = "";
        DataCenter.chatData:setChatShowItem(0, nil);
        return;
    end

	local str = self.msgText.text;
	if self.defaultMsg == str or string.len(str) == 0 then
		OperateAlert.showLangValue(171023);
		return;
	end

	if str == "A6D2D735" then
		Lua_WindowUtil.openWin("Lua_DebugWindow");
		return;
	end
	if str == "BA82821A" then
		Lua_MsgUtil.callFunc("SHOW_LOG_CHANGE");
		return;
	end
	if str == "65FACA33" then
		DataCenter.showVersion = true;
		return;
	end
	if str == "5BEB2EC8" then
		Lua_MsgUtil.callFunc("SHOW_FPS", true);
		return;
	end

    local contentData = DataCenter.chatData.contentData;
    if contentData ~= nil then
        local s;
        if DataCenter.chatData.contentType == Lua_ChatData.CONTENT_XUANYAO then
            s = "["..contentData.name.."]";
            s = string.gsub(s, "%[", "%%%[");
            s = string.gsub(s, "%(", "%%%(");
            s = string.gsub(s, "%)", "%%%)");
            s = string.gsub(s, "%]", "%%%]");
            s = string.gsub(s, "%*", "%%%*");
            s = string.gsub(s, "-", "");
            str = string.gsub(str, "-", "");
            str = string.gsub(str, s, "〖〗");
        end
    end

    local rs = Lua_ChatUtil.replaceChatMsg(str);
    local canSend = 0--Lua_ChatUtil.checkSendMsg(rs);
    if canSend == 1 or canSend == 2 then
        OperateAlert.showLangValue(171020);
    else
        Lua_ChatUtil.sendMsg(self.selectChannel, str,true,true);
    end
	self.curItemId = nil;
    self.msgText:setDefaultLangValue(self.defaultLangId)
	self.msgText.text = "";
    DataCenter.chatData:setChatShowItem(0, nil);
end

function Lua_ChatWindow:dispose()
    if self.btnNames ~= nil then
        self.btnNames:clear();
        self.btnNames = nil;
    end

    if self.btnList ~= nil then
        self.btnList:dispose()
        self.btnList=nil;
    end

    if self.friendList ~= nil then
        self.friendList:dispose()
        self.friendList=nil;
    end

    if self.dragContainer ~= nil then
        self.dragContainer:dispose()
        self.dragContainer=nil;
    end

    if self.pointObject ~= nil and IsNil(self.pointObject) == false then
        UnityEngine.GameObject.Destroy(self.pointObject);
        self.pointObject = nil;
    end

    if self.faceList ~= nil then
        self.faceList:dispose();
        self.faceList = nil;
    end

    DataCenter.chatData:setChatShowItem(0, nil);
    DataCenter.chatData.openChannelTag=0;
    DataCenter.chatData.selectPrivate=0;
    Lua_CommonUtil.removeTimer(self,self.checkVoiceTime);
    Lua_MsgUtil.callFunc("CHAT_RED_UPDATE");
    self:superCall("dispose");
end
















-------------------------------------------------------------------------


Lua_FaceItem = class("Lua_FaceItem", Lua_ListCell);
function Lua_FaceItem:buildShowItem()
    self:superCall("buildShowItem");
    self.face = UICreate.createUIAtlasImage(self.content, "emoji_altas", "Chat_icon_001", 0, 0, 45, 45);
end

function Lua_FaceItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end

function Lua_FaceItem:setData(data)
    if data == nil then
        return;
    end

    self.data=data;
    self.face.name = data;
    self.face:setAltas("emoji_altas", "Chat_icon_"..data)
end

function Lua_FaceItem:onPressClick()
    if self.data == nil then
        return;
    end
    Lua_MsgUtil.callFunc("CHAT_ADD_FACE", self.data);
end